#!/usr/bin/perl -w

if (@ARGV != 2) {
  print <<_EOF_;
Content-type: text/html

<!DOCTYPE html PUBLIC "-//IETF//DTD HTML 2.0//EN">
<html><head><title>gman.pl: invalid use</title></head>
<body>
<h1>gman.pl cannot be used without arguments.</h1>
</body></html>
_EOF_
  die;
}

my $section = $ARGV[0]; # should also have some sanity check
my $cut = "/usr/bin/cut -f 1 -d \" \" ";
my $name = $ARGV[1];
my $man = "/usr/bin/man";
my $man2html = "/usr/local/bin/man2html -nodepage ";
my $path = `$man -w $section $name |$cut`; chomp $path; $path =~ s/\s*$//;

unless (-s "$path") {
  warn "not -s $path\n";
  $name = lc $name;
  $path = `$man -w $section $name |$cut`; chomp $path; $path =~ s/\s*$//;
}
unless (-s "$path") {
  warn "not -s $path\n";
	print <<end_of_line;
Content-type: text/html

<!DOCTYPE html PUBLIC "-//IETF//DTD HTML 2.0//EN">
<html><head>
<title>404 Not Found</title>
</head><body>
<H1>Not Found</H1>
The requested man page $name($section) was not found on this server.
</body></html>
end_of_line
;
}

my $page = `$man $section $name |$man2html`;

# $page =~ s/^Content-type: text\/html\n\n// if (not run as cgi...);

print <<eof;
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML//EN">
eof
;

print $page;

